import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { useDispatch, useSelector } from 'react-redux'
import { A6_APIdel, A6_APIgetList, A6_APIgetNumAll } from '@/store/action/A6record'
import { RootState } from '@/store'
import { MessageFu } from '@/utils/message'
import { A6FromDataType, A6tableType } from './type'
import { Button, DatePicker, Input } from 'antd'
import MyPopconfirm from '@/components/MyPopconfirm'
import MyTable from '@/components/MyTable'
import { A6tableC } from '@/utils/tableData'
import A6auth from './A6auth'
import LocStat from './LocStat'

const { RangePicker } = DatePicker

const fromDataBase: A6FromDataType = {
  searchKey: '',
  pageNum: 1,
  pageSize: 10,
  startTime: '',
  endTime: ''
}

function A6record() {
  const dispatch = useDispatch()

  // 总人数
  const [numAll, setNumAll] = useState(0)

  const [fromData, setFromData] = useState(fromDataBase)

  const getListFu = useCallback(async () => {
    dispatch(A6_APIgetList(fromData))

    // 获取总人数
    const res = await A6_APIgetNumAll(fromData)
    if (res.code === 0) setNumAll(res.data)
  }, [dispatch, fromData])

  useEffect(() => {
    getListFu()
  }, [getListFu])

  const { tableInfo } = useSelector((state: RootState) => state.A6record)

  const delTableFu = useCallback(
    async (id: number) => {
      const res = await A6_APIdel(id)
      if (res.code === 0) {
        MessageFu.success('删除成功!')
        getListFu()
      }
    },
    [getListFu]
  )

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: A6tableType) => (
          <>
            {item.status === 0 ? (
              <Button
                size='small'
                type='text'
                onClick={() =>
                  setAuthId({
                    id: item.id,
                    status: item.status
                  })
                }
              >
                审核
              </Button>
            ) : null}

            <MyPopconfirm txtK='删除' onConfirm={() => delTableFu(item.id)} />
          </>
        )
      }
    ]
  }, [delTableFu])

  const [inputKey, setInputKey] = useState(1)

  // 输入框的输入
  const timeRef = useRef(-1)
  const txtChangeFu = useCallback(
    (e: React.ChangeEvent<HTMLInputElement>, key: 'searchKey') => {
      clearTimeout(timeRef.current)
      timeRef.current = window.setTimeout(() => {
        setFromData({
          ...fromData,
          [key]: e.target.value.replaceAll("'", ''),
          pageNum: 1
        })
      }, 500)
    },
    [fromData]
  )

  // 点击重置
  const resetSelectFu = useCallback(() => {
    setInputKey(Date.now())
    setFromData(fromDataBase)
  }, [])

  // 时间选择器改变
  const timeChange = useCallback(
    (date: any, dateString: any) => {
      let startTime = ''
      let endTime = ''
      if (dateString[0] && dateString[1]) {
        startTime = dateString[0] + ' 00:00:00'
        endTime = dateString[1] + ' 23:59:59'
      }
      setFromData({ ...fromData, startTime, endTime, pageNum: 1 })
    },
    [fromData]
  )

  // 点击审核
  const [authId, setAuthId] = useState({
    id: 0,
    status: 0
  })

  // 点击地区统计
  const [locShow, setLocShow] = useState(false)

  return (
    <div className={styles.A6record}>
      <div className='pageTitle'>课程预约记录</div>

      <div className='A6top'>
        <div className='A6top1'>
          <div className='A6topRow'>
            <span>搜索：</span>
            <Input
              key={inputKey}
              maxLength={50}
              style={{ width: 200 }}
              placeholder='请输入姓名/联系电话'
              allowClear
              onChange={e => txtChangeFu(e, 'searchKey')}
            />
          </div>
          <div className='A6topRow'>
            <span>预约日期：</span>
            <RangePicker key={inputKey} onChange={timeChange} />
          </div>
        </div>
        <div className='A6top1'>
          <Button onClick={() => setLocShow(true)}>地区统计</Button>&emsp;
          <Button onClick={resetSelectFu}>重置</Button>
        </div>
      </div>

      <MyTable
        yHeight={604}
        list={tableInfo.list}
        columnsTemp={A6tableC}
        lastBtn={tableLastBtn}
        pageNum={fromData.pageNum}
        pageSize={fromData.pageSize}
        total={tableInfo.total}
        onChange={(pageNum, pageSize) => setFromData({ ...fromData, pageNum, pageSize })}
      />
      {/* 总人数 */}
      <div className='A6numAll'>总人数：{numAll}</div>

      {/* 点击审核 */}
      {authId.id ? (
        <A6auth
          sId={authId.id}
          status={authId.status}
          closeFu={() => setAuthId({ id: 0, status: 0 })}
          editTableFu={getListFu}
        />
      ) : null}

      {/* 点击地区统计 */}
      {locShow ? (
        <LocStat type='课程' apiObj={fromData} closeFu={() => setLocShow(false)} />
      ) : null}
    </div>
  )
}

const MemoA6record = React.memo(A6record)

export default MemoA6record
